
_interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0

	BTFSS      INTE_bit+0, BitPos(INTE_bit+0)
	GOTO       L__interrupt2
	BTFSS      INTF_bit+0, BitPos(INTF_bit+0)
	GOTO       L__interrupt5
	MOVF       _sw_mode+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__interrupt8
	MOVF       _tmr_high+0, 0
	MOVWF      TMR1H+0
	MOVF       _tmr_low+0, 0
	MOVWF      TMR1L+0
	BSF        TMR1IE_bit+0, BitPos(TMR1IE_bit+0)
	BCF        TMR1IF_bit+0, BitPos(TMR1IF_bit+0)
	BSF        TMR1ON_bit+0, BitPos(TMR1ON_bit+0)
	GOTO       L__interrupt9
L__interrupt8:
	MOVF       _duty+0, 0
	XORLW      0
	MOVLW      255
	BTFSC      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       _duty+0, 0
	XORLW      100
	MOVLW      255
	BTFSC      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__interrupt11
	MOVF       _mode_cycle+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__interrupt14
	CLRF       TMR2+0
	BSF        RB1_bit+0, BitPos(RB1_bit+0)
	BSF        TMR2IE_bit+0, BitPos(TMR2IE_bit+0)
	BCF        TMR2IF_bit+0, BitPos(TMR2IF_bit+0)
	BSF        TMR2ON_bit+0, BitPos(TMR2ON_bit+0)
L__interrupt14:
	DECF       _cycle_counter+0, 1
	MOVF       _cycle_counter+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__interrupt17
	MOVF       _mode_cycle+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__interrupt20
	MOVLW      1
	MOVWF      _mode_cycle+0
	MOVF       _off_count+0, 0
	MOVWF      _cycle_counter+0
	GOTO       L__interrupt21
L__interrupt20:
	CLRF       _mode_cycle+0
	MOVF       _on_count+0, 0
	MOVWF      _cycle_counter+0
L__interrupt21:
L__interrupt17:
L__interrupt11:
L__interrupt9:
	BCF        INTF_bit+0, BitPos(INTF_bit+0)
L__interrupt5:
L__interrupt2:
	BTFSS      T0IF_bit+0, BitPos(T0IF_bit+0)
	GOTO       L__interrupt23
	MOVLW      72
	MOVWF      TMR0+0
	MOVF       _led_pos+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__interrupt28
	BSF        RA1_bit+0, BitPos(RA1_bit+0)
	MOVF       _led_val1+0, 0
	MOVWF      PORTC+0
	BCF        RA3_bit+0, BitPos(RA3_bit+0)
	MOVLW      2
	MOVWF      _led_pos+0
	GOTO       L__interrupt25
L__interrupt28:
	MOVF       _led_pos+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__interrupt31
	BSF        RA3_bit+0, BitPos(RA3_bit+0)
	MOVF       _led_val2+0, 0
	MOVWF      PORTC+0
	BCF        RA2_bit+0, BitPos(RA2_bit+0)
	MOVLW      3
	MOVWF      _led_pos+0
	GOTO       L__interrupt25
L__interrupt31:
	MOVF       _led_pos+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L__interrupt34
	BSF        RA2_bit+0, BitPos(RA2_bit+0)
	MOVF       _led_val3+0, 0
	MOVWF      PORTC+0
	BCF        RA1_bit+0, BitPos(RA1_bit+0)
	MOVLW      1
	MOVWF      _led_pos+0
	GOTO       L__interrupt25
L__interrupt34:
L__interrupt25:
	BCF        T0IF_bit+0, BitPos(T0IF_bit+0)
L__interrupt23:
	BTFSS      TMR1IF_bit+0, BitPos(TMR1IF_bit+0)
	GOTO       L__interrupt36
	BCF        TMR1ON_bit+0, BitPos(TMR1ON_bit+0)
	CLRF       TMR2+0
	BSF        RB1_bit+0, BitPos(RB1_bit+0)
	BSF        TMR2IE_bit+0, BitPos(TMR2IE_bit+0)
	BCF        TMR2IF_bit+0, BitPos(TMR2IF_bit+0)
	BSF        TMR2ON_bit+0, BitPos(TMR2ON_bit+0)
	BCF        TMR1IE_bit+0, BitPos(TMR1IE_bit+0)
	BCF        TMR1IF_bit+0, BitPos(TMR1IF_bit+0)
L__interrupt36:
	BTFSS      TMR2IF_bit+0, BitPos(TMR2IF_bit+0)
	GOTO       L__interrupt39
	BCF        RB1_bit+0, BitPos(RB1_bit+0)
	BCF        TMR2IE_bit+0, BitPos(TMR2IE_bit+0)
	BCF        TMR2IF_bit+0, BitPos(TMR2IF_bit+0)
	BCF        TMR2ON_bit+0, BitPos(TMR2ON_bit+0)
L__interrupt39:
L_end_interrupt:
L__interrupt289:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of _interrupt

_decode_number:

	MOVF       FARG_decode_number_num+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__decode_number45
	MOVLW      192
	MOVWF      R1+0
	GOTO       L__decode_number42
L__decode_number45:
	MOVF       FARG_decode_number_num+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__decode_number48
	MOVLW      249
	MOVWF      R1+0
	GOTO       L__decode_number42
L__decode_number48:
	MOVF       FARG_decode_number_num+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__decode_number51
	MOVLW      164
	MOVWF      R1+0
	GOTO       L__decode_number42
L__decode_number51:
	MOVF       FARG_decode_number_num+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L__decode_number54
	MOVLW      176
	MOVWF      R1+0
	GOTO       L__decode_number42
L__decode_number54:
	MOVF       FARG_decode_number_num+0, 0
	XORLW      4
	BTFSS      STATUS+0, 2
	GOTO       L__decode_number57
	MOVLW      153
	MOVWF      R1+0
	GOTO       L__decode_number42
L__decode_number57:
	MOVF       FARG_decode_number_num+0, 0
	XORLW      5
	BTFSS      STATUS+0, 2
	GOTO       L__decode_number60
	MOVLW      146
	MOVWF      R1+0
	GOTO       L__decode_number42
L__decode_number60:
	MOVF       FARG_decode_number_num+0, 0
	XORLW      6
	BTFSS      STATUS+0, 2
	GOTO       L__decode_number63
	MOVLW      130
	MOVWF      R1+0
	GOTO       L__decode_number42
L__decode_number63:
	MOVF       FARG_decode_number_num+0, 0
	XORLW      7
	BTFSS      STATUS+0, 2
	GOTO       L__decode_number66
	MOVLW      248
	MOVWF      R1+0
	GOTO       L__decode_number42
L__decode_number66:
	MOVF       FARG_decode_number_num+0, 0
	XORLW      8
	BTFSS      STATUS+0, 2
	GOTO       L__decode_number69
	MOVLW      128
	MOVWF      R1+0
	GOTO       L__decode_number42
L__decode_number69:
	MOVF       FARG_decode_number_num+0, 0
	XORLW      9
	BTFSS      STATUS+0, 2
	GOTO       L__decode_number72
	MOVLW      144
	MOVWF      R1+0
	GOTO       L__decode_number42
L__decode_number72:
L__decode_number42:
	MOVF       R1+0, 0
	MOVWF      R0+0
L_end_decode_number:
	RETURN
; end of _decode_number

_display_number:

	MOVLW      10
	MOVWF      R4+0
	MOVF       FARG_display_number_num+0, 0
	MOVWF      R0+0
	CALL       _Div_8x8_U+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      FARG_decode_number_num+0
	CALL       _decode_number+0
	MOVF       R0+0, 0
	MOVWF      display_number_tmp_led3+0
	MOVLW      10
	MOVWF      R4+0
	MOVF       FARG_display_number_num+0, 0
	MOVWF      R0+0
	CALL       _Div_8x8_U+0
	MOVF       R0+0, 0
	MOVWF      FARG_display_number_num+0
	MOVLW      10
	MOVWF      R4+0
	CALL       _Div_8x8_U+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      FARG_decode_number_num+0
	CALL       _decode_number+0
	MOVF       R0+0, 0
	MOVWF      display_number_tmp_led2+0
	MOVLW      10
	MOVWF      R4+0
	MOVF       FARG_display_number_num+0, 0
	MOVWF      R0+0
	CALL       _Div_8x8_U+0
	MOVF       R0+0, 0
	MOVWF      FARG_display_number_num+0
	MOVF       R0+0, 0
	MOVWF      FARG_decode_number_num+0
	CALL       _decode_number+0
	MOVF       R0+0, 0
	MOVWF      display_number_tmp_led1+0
	MOVF       R0+0, 0
	XORLW      192
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       display_number_tmp_led2+0, 0
	XORLW      192
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__display_number75
	MOVLW      255
	MOVWF      display_number_tmp_led2+0
L__display_number75:
	MOVF       display_number_tmp_led1+0, 0
	XORLW      192
	BTFSS      STATUS+0, 2
	GOTO       L__display_number78
	MOVLW      255
	MOVWF      display_number_tmp_led1+0
L__display_number78:
	MOVF       display_number_tmp_led1+0, 0
	MOVWF      _led_val1+0
	MOVF       display_number_tmp_led2+0, 0
	MOVWF      _led_val2+0
	MOVF       display_number_tmp_led3+0, 0
	MOVWF      _led_val3+0
L_end_display_number:
	RETURN
; end of _display_number

_display_mode:

	MOVF       FARG_display_mode_mode+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__display_mode84
	MOVLW      191
	MOVWF      _led_val1+0
	MOVLW      192
	MOVWF      _led_val2+0
	MOVLW      191
	MOVWF      _led_val3+0
	GOTO       L__display_mode81
L__display_mode84:
	MOVF       FARG_display_mode_mode+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__display_mode87
	MOVLW      137
	MOVWF      _led_val1+0
	MOVLW      134
	MOVWF      _led_val2+0
	MOVLW      136
	MOVWF      _led_val3+0
	GOTO       L__display_mode81
L__display_mode87:
	MOVF       FARG_display_mode_mode+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__display_mode90
	MOVLW      146
	MOVWF      _led_val1+0
	MOVLW      192
	MOVWF      _led_val2+0
	MOVLW      199
	MOVWF      _led_val3+0
	GOTO       L__display_mode81
L__display_mode90:
L__display_mode81:
L_end_display_mode:
	RETURN
; end of _display_mode

_rotary_encoder:

	MOVLW      0
	BTFSC      RB5_bit+0, BitPos(RB5_bit+0)
	MOVLW      1
	MOVWF      R3+0
	MOVLW      0
	BTFSC      RB4_bit+0, BitPos(RB4_bit+0)
	MOVLW      1
	MOVWF      R4+0
	CLRF       R2+0
	MOVF       _Rotary_Enc_A+0, 0
	XORLW      1
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       R3+0, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ANDWF      R1+0, 1
	MOVF       R4+0, 0
	XORLW      1
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__rotary_encoder93
	MOVLW      1
	MOVWF      _Rotary_Stat+0
	MOVLW      255
	MOVWF      _Rotary_A_Lock+0
L__rotary_encoder93:
	MOVF       _Rotary_A_Lock+0, 0
	XORLW      255
	BTFSS      STATUS+0, 2
	GOTO       L__rotary_encoder96
	MOVF       R3+0, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       R4+0, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__rotary_encoder99
	MOVF       _Rotary_Stat+0, 0
	MOVWF      R2+0
	CLRF       _Rotary_A_Lock+0
L__rotary_encoder99:
L__rotary_encoder96:
	MOVF       _Rotary_Enc_B+0, 0
	XORLW      1
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       R4+0, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ANDWF      R1+0, 1
	MOVF       R3+0, 0
	XORLW      1
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__rotary_encoder102
	MOVLW      2
	MOVWF      _Rotary_Stat+0
	MOVLW      255
	MOVWF      _Rotary_B_Lock+0
L__rotary_encoder102:
	MOVF       _Rotary_B_Lock+0, 0
	XORLW      255
	BTFSS      STATUS+0, 2
	GOTO       L__rotary_encoder105
	MOVF       R3+0, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       R4+0, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__rotary_encoder108
	MOVF       _Rotary_Stat+0, 0
	MOVWF      R2+0
	CLRF       _Rotary_B_Lock+0
L__rotary_encoder108:
L__rotary_encoder105:
	MOVF       R3+0, 0
	MOVWF      _Rotary_Enc_A+0
	MOVF       R4+0, 0
	MOVWF      _Rotary_Enc_B+0
	MOVF       R2+0, 0
	MOVWF      R0+0
L_end_rotary_encoder:
	RETURN
; end of _rotary_encoder

_calc_tmr:

	MOVF       FARG_calc_tmr_freq+0, 0
	XORLW      50
	BTFSS      STATUS+0, 2
	GOTO       L__calc_tmr112
	MOVLW      80
	MOVWF      calc_tmr_period+0
	MOVLW      195
	MOVWF      calc_tmr_period+1
	CLRF       calc_tmr_period+2
	CLRF       calc_tmr_period+3
	GOTO       L__calc_tmr113
L__calc_tmr112:
	MOVLW      194
	MOVWF      calc_tmr_period+0
	MOVLW      162
	MOVWF      calc_tmr_period+1
	CLRF       calc_tmr_period+2
	CLRF       calc_tmr_period+3
L__calc_tmr113:
	MOVLW      5
	MOVWF      R4+0
	MOVF       FARG_calc_tmr_duty+0, 0
	MOVWF      R0+0
	CALL       _Div_8x8_U+0
	MOVF       R0+0, 0
	MOVWF      R2+0
	CLRF       R2+1
	RLF        R2+0, 1
	RLF        R2+1, 1
	BCF        R2+0, 0
	MOVF       R2+0, 0
	ADDLW      _ACRV+0
	MOVWF      R0+0
	MOVLW      hi_addr(_ACRV+0)
	BTFSC      STATUS+0, 0
	ADDLW      1
	ADDWF      R2+1, 0
	MOVWF      R0+1
	MOVF       R0+0, 0
	MOVWF      ___DoICPAddr+0
	MOVF       R0+1, 0
	MOVWF      ___DoICPAddr+1
	CALL       _____DoICP+0
	MOVWF      R0+0
	INCF       ___DoICPAddr+0, 1
	BTFSC      STATUS+0, 2
	INCF       ___DoICPAddr+1, 1
	CALL       _____DoICP+0
	MOVWF      R0+1
	MOVLW      0
	MOVWF      R0+2
	MOVWF      R0+3
	MOVF       calc_tmr_period+0, 0
	MOVWF      R4+0
	MOVF       calc_tmr_period+1, 0
	MOVWF      R4+1
	MOVF       calc_tmr_period+2, 0
	MOVWF      R4+2
	MOVF       calc_tmr_period+3, 0
	MOVWF      R4+3
	CALL       _Mul_32x32_U+0
	MOVLW      232
	MOVWF      R4+0
	MOVLW      3
	MOVWF      R4+1
	CLRF       R4+2
	CLRF       R4+3
	CALL       _Div_32x32_U+0
	MOVF       calc_tmr_period+0, 0
	MOVWF      R4+0
	MOVF       calc_tmr_period+1, 0
	MOVWF      R4+1
	MOVF       calc_tmr_period+2, 0
	MOVWF      R4+2
	MOVF       calc_tmr_period+3, 0
	MOVWF      R4+3
	MOVF       R0+0, 0
	SUBWF      R4+0, 1
	MOVF       R0+1, 0
	BTFSS      STATUS+0, 0
	INCFSZ     R0+1, 0
	SUBWF      R4+1, 1
	MOVF       R0+2, 0
	BTFSS      STATUS+0, 0
	INCFSZ     R0+2, 0
	SUBWF      R4+2, 1
	MOVF       R0+3, 0
	BTFSS      STATUS+0, 0
	INCFSZ     R0+3, 0
	SUBWF      R4+3, 1
	MOVLW      255
	MOVWF      R0+0
	MOVLW      255
	MOVWF      R0+1
	CLRF       R0+2
	CLRF       R0+3
	MOVF       R0+0, 0
	MOVWF      calc_tmr_tmr_value+0
	MOVF       R0+1, 0
	MOVWF      calc_tmr_tmr_value+1
	MOVF       R0+2, 0
	MOVWF      calc_tmr_tmr_value+2
	MOVF       R0+3, 0
	MOVWF      calc_tmr_tmr_value+3
	MOVF       R4+0, 0
	SUBWF      calc_tmr_tmr_value+0, 1
	MOVF       R4+1, 0
	BTFSS      STATUS+0, 0
	INCFSZ     R4+1, 0
	SUBWF      calc_tmr_tmr_value+1, 1
	MOVF       R4+2, 0
	BTFSS      STATUS+0, 0
	INCFSZ     R4+2, 0
	SUBWF      calc_tmr_tmr_value+2, 1
	MOVF       R4+3, 0
	BTFSS      STATUS+0, 0
	INCFSZ     R4+3, 0
	SUBWF      calc_tmr_tmr_value+3, 1
	MOVF       calc_tmr_tmr_value+0, 0
	MOVWF      _tmr_low+0
	MOVF       calc_tmr_tmr_value+1, 0
	MOVWF      _tmr_high+0
L_end_calc_tmr:
	RETURN
; end of _calc_tmr

_main:

	BCF        RB1_bit+0, BitPos(RB1_bit+0)
	CLRF       TRISC+0
	BCF        TRISA3_bit+0, BitPos(TRISA3_bit+0)
	BCF        TRISA2_bit+0, BitPos(TRISA2_bit+0)
	BCF        TRISA1_bit+0, BitPos(TRISA1_bit+0)
	BCF        TRISB1_bit+0, BitPos(TRISB1_bit+0)
	BSF        TRISB5_bit+0, BitPos(TRISB5_bit+0)
	BSF        TRISB4_bit+0, BitPos(TRISB4_bit+0)
	BSF        TRISB0_bit+0, BitPos(TRISB0_bit+0)
	BSF        TRISB3_bit+0, BitPos(TRISB3_bit+0)
	BSF        NOT_RBPU_bit+0, BitPos(NOT_RBPU_bit+0)
	BCF        PCFG3_bit+0, BitPos(PCFG3_bit+0)
	BSF        PCFG2_bit+0, BitPos(PCFG2_bit+0)
	BSF        PCFG1_bit+0, BitPos(PCFG1_bit+0)
	BSF        PS2_bit+0, BitPos(PS2_bit+0)
	BCF        PS1_bit+0, BitPos(PS1_bit+0)
	BCF        PS0_bit+0, BitPos(PS0_bit+0)
	BCF        PSA_bit+0, BitPos(PSA_bit+0)
	BSF        T0IE_bit+0, BitPos(T0IE_bit+0)
	BCF        T0IF_bit+0, BitPos(T0IF_bit+0)
	MOVLW      72
	MOVWF      TMR0+0
	BCF        T0CS_bit+0, BitPos(T0CS_bit+0)
	BCF        TMR1ON_bit+0, BitPos(TMR1ON_bit+0)
	BSF        PEIE_bit+0, BitPos(PEIE_bit+0)
	BCF        TMR1IE_bit+0, BitPos(TMR1IE_bit+0)
	BCF        TMR1IF_bit+0, BitPos(TMR1IF_bit+0)
	BCF        T1CKPS1_bit+0, BitPos(T1CKPS1_bit+0)
	BCF        T1CKPS0_bit+0, BitPos(T1CKPS0_bit+0)
	BCF        TMR1CS_bit+0, BitPos(TMR1CS_bit+0)
	BSF        TMR1ON_bit+0, BitPos(TMR1ON_bit+0)
	BCF        TMR2ON_bit+0, BitPos(TMR2ON_bit+0)
	BCF        TOUTPS3_bit+0, BitPos(TOUTPS3_bit+0)
	BCF        TOUTPS2_bit+0, BitPos(TOUTPS2_bit+0)
	BCF        TOUTPS1_bit+0, BitPos(TOUTPS1_bit+0)
	BSF        TOUTPS0_bit+0, BitPos(TOUTPS0_bit+0)
	BCF        T2CKPS0_bit+0, BitPos(T2CKPS0_bit+0)
	BCF        T2CKPS1_bit+0, BitPos(T2CKPS1_bit+0)
	BCF        TMR2IE_bit+0, BitPos(TMR2IE_bit+0)
	BCF        TMR2IF_bit+0, BitPos(TMR2IF_bit+0)
	MOVLW      249
	MOVWF      PR2+0
	CLRF       _Rotary_A_Lock+0
	CLRF       _Rotary_B_Lock+0
	BSF        RA3_bit+0, BitPos(RA3_bit+0)
	BSF        RA2_bit+0, BitPos(RA2_bit+0)
	BSF        RA1_bit+0, BitPos(RA1_bit+0)
	MOVLW      1
	MOVWF      _led_pos+0
	BSF        TMR1ON_bit+0, BitPos(TMR1ON_bit+0)
L__main116:
	BTFSS      RB0_bit+0, BitPos(RB0_bit+0)
	GOTO       L__main116
	CLRF       TMR1H+0
	CLRF       TMR1L+0
L__main121:
	BTFSC      RB0_bit+0, BitPos(RB0_bit+0)
	GOTO       L__main121
L__main126:
	BTFSS      RB0_bit+0, BitPos(RB0_bit+0)
	GOTO       L__main126
	MOVF       TMR1H+0, 0
	MOVWF      main_tmrH_byte+0
	MOVF       main_tmrH_byte+0, 0
	MOVWF      R0+1
	CLRF       R0+0
	MOVF       main_tmrH_byte+0, 0
	ADDWF      R0+0, 0
	MOVWF      R2+0
	MOVF       R0+1, 0
	BTFSC      STATUS+0, 0
	ADDLW      1
	MOVWF      R2+1
	MOVF       R2+0, 0
	MOVWF      main_period+0
	MOVF       R2+1, 0
	MOVWF      main_period+1
	CLRF       main_freq+0
	MOVF       R2+1, 0
	SUBLW      193
	BTFSS      STATUS+0, 2
	GOTO       L__main296
	MOVF       R2+0, 0
	SUBLW      92
L__main296:
	MOVLW      255
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVLW      197
	SUBWF      R2+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main297
	MOVLW      68
	SUBWF      R2+0, 0
L__main297:
	MOVLW      255
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main131
	MOVLW      50
	MOVWF      main_freq+0
L__main131:
	MOVF       main_period+1, 0
	SUBLW      161
	BTFSS      STATUS+0, 2
	GOTO       L__main298
	MOVF       main_period+0, 0
	SUBLW      34
L__main298:
	MOVLW      255
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVLW      164
	SUBWF      main_period+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main299
	MOVLW      98
	SUBWF      main_period+0, 0
L__main299:
	MOVLW      255
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main134
	MOVLW      60
	MOVWF      main_freq+0
L__main134:
	BCF        TMR1ON_bit+0, BitPos(TMR1ON_bit+0)
	BCF        TMR2ON_bit+0, BitPos(TMR2ON_bit+0)
	BSF        INTCON+0, 7
	CLRF       FARG_EEPROM_Read_address+0
	CALL       _EEPROM_Read+0
	MOVF       R0+0, 0
	MOVWF      _sw_mode+0
	BTFSC      RB3_bit+0, BitPos(RB3_bit+0)
	GOTO       L__main137
	MOVF       _sw_mode+0, 0
	MOVWF      FARG_display_mode_mode+0
	CALL       _display_mode+0
L__main140:
	BTFSS      RB3_bit+0, BitPos(RB3_bit+0)
	GOTO       L__main140
	MOVLW      130
	MOVWF      R12+0
	MOVLW      221
	MOVWF      R13+0
L__main144:
	DECFSZ     R13+0, 1
	GOTO       L__main144
	DECFSZ     R12+0, 1
	GOTO       L__main144
	NOP
	NOP
L__main146:
	CALL       _rotary_encoder+0
	MOVF       R0+0, 0
	MOVWF      main_turn+0
	MOVF       R0+0, 0
	XORLW      1
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R2+0
	MOVF       R0+0, 0
	XORLW      2
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       R1+0, 0
	IORWF      R2+0, 0
	MOVWF      R0+0
	BTFSC      STATUS+0, 2
	GOTO       L__main151
	MOVF       _sw_mode+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__main156
	MOVLW      1
	MOVWF      _sw_mode+0
	GOTO       L__main153
L__main156:
	MOVF       _sw_mode+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__main159
	MOVLW      2
	MOVWF      _sw_mode+0
	GOTO       L__main153
L__main159:
	MOVF       _sw_mode+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__main162
	CLRF       _sw_mode+0
	GOTO       L__main153
L__main162:
L__main153:
	MOVF       _sw_mode+0, 0
	MOVWF      FARG_display_mode_mode+0
	CALL       _display_mode+0
	CLRF       FARG_EEPROM_Write_address+0
	MOVF       _sw_mode+0, 0
	MOVWF      FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
L__main151:
	BTFSC      RB3_bit+0, BitPos(RB3_bit+0)
	GOTO       L__main164
	GOTO       L__main147
L__main164:
	GOTO       L__main146
L__main147:
L__main137:
	MOVF       _sw_mode+0, 0
	XORLW      1
	MOVLW      255
	BTFSC      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       _sw_mode+0, 0
	XORLW      2
	MOVLW      255
	BTFSC      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ANDWF      R1+0, 1
	MOVF       _sw_mode+0, 0
	XORLW      0
	MOVLW      255
	BTFSC      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main167
	CLRF       _sw_mode+0
	CLRF       FARG_EEPROM_Write_address+0
	CLRF       FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
L__main167:
	MOVF       _sw_mode+0, 0
	XORLW      1
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       _sw_mode+0, 0
	XORLW      2
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	IORWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main170
	MOVLW      1
	MOVWF      _mode_cycle+0
	MOVLW      1
	MOVWF      _cycle_counter+0
L__main170:
	MOVF       _sw_mode+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__main173
	MOVLW      1
	MOVWF      FARG_EEPROM_Read_address+0
	CALL       _EEPROM_Read+0
	MOVF       R0+0, 0
	MOVWF      _duty+0
	MOVF       R0+0, 0
	SUBLW      100
	BTFSC      STATUS+0, 0
	GOTO       L__main176
	MOVLW      100
	MOVWF      _duty+0
	MOVLW      1
	MOVWF      FARG_EEPROM_Write_address+0
	MOVLW      100
	MOVWF      FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
L__main176:
	MOVF       _duty+0, 0
	XORLW      100
	BTFSS      STATUS+0, 2
	GOTO       L__main179
	BSF        RB1_bit+0, BitPos(RB1_bit+0)
L__main179:
	MOVLW      5
	MOVWF      R4+0
	MOVF       _duty+0, 0
	MOVWF      R0+0
	CALL       _Div_8x8_U+0
	MOVF       R0+0, 0
	MOVWF      R1+0
	RLF        R1+0, 1
	BCF        R1+0, 0
	MOVF       R1+0, 0
	MOVWF      _on_count+0
	MOVF       R1+0, 0
	SUBLW      40
	MOVWF      _off_count+0
	GOTO       L__main174
L__main173:
	CLRF       _duty+0
L__main174:
	MOVF       main_freq+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__main184
	MOVLW      134
	MOVWF      _led_val1+0
	MOVLW      255
	MOVWF      _led_val2+0
	MOVLW      255
	MOVWF      _led_val3+0
L__main186:
	GOTO       L__main186
L__main184:
	MOVF       main_freq+0, 0
	XORLW      50
	BTFSS      STATUS+0, 2
	GOTO       L__main192
	MOVLW      146
	MOVWF      _led_val1+0
	MOVLW      192
	MOVWF      _led_val2+0
	MOVLW      137
	MOVWF      _led_val3+0
	GOTO       L__main181
L__main192:
	MOVF       main_freq+0, 0
	XORLW      60
	BTFSS      STATUS+0, 2
	GOTO       L__main195
	MOVLW      130
	MOVWF      _led_val1+0
	MOVLW      192
	MOVWF      _led_val2+0
	MOVLW      137
	MOVWF      _led_val3+0
	GOTO       L__main181
L__main195:
L__main181:
	MOVLW      13
	MOVWF      R11+0
	MOVLW      175
	MOVWF      R12+0
	MOVLW      182
	MOVWF      R13+0
L__main196:
	DECFSZ     R13+0, 1
	GOTO       L__main196
	DECFSZ     R12+0, 1
	GOTO       L__main196
	DECFSZ     R11+0, 1
	GOTO       L__main196
	NOP
	MOVF       _sw_mode+0, 0
	MOVWF      FARG_display_mode_mode+0
	CALL       _display_mode+0
	MOVLW      13
	MOVWF      R11+0
	MOVLW      175
	MOVWF      R12+0
	MOVLW      182
	MOVWF      R13+0
L__main197:
	DECFSZ     R13+0, 1
	GOTO       L__main197
	DECFSZ     R12+0, 1
	GOTO       L__main197
	DECFSZ     R11+0, 1
	GOTO       L__main197
	NOP
	MOVF       _duty+0, 0
	MOVWF      FARG_display_number_num+0
	CALL       _display_number+0
	BSF        INTEDG_bit+0, BitPos(INTEDG_bit+0)
	MOVF       _duty+0, 0
	XORLW      0
	MOVLW      255
	BTFSC      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       _duty+0, 0
	XORLW      100
	MOVLW      255
	BTFSC      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main199
	BSF        INTE_bit+0, BitPos(INTE_bit+0)
L__main199:
L__main202:
	CALL       _rotary_encoder+0
	MOVF       R0+0, 0
	MOVWF      main_turn+0
	MOVF       R0+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__main207
	MOVLW      100
	SUBWF      _duty+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L__main210
	MOVF       _sw_mode+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__main215
	MOVLW      5
	ADDWF      _duty+0, 1
	GOTO       L__main212
L__main215:
	MOVF       _sw_mode+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__main218
	MOVF       _duty+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__main222
	MOVLW      20
	MOVWF      _duty+0
	MOVLW      1
	MOVWF      _on_count+0
	MOVLW      4
	MOVWF      _off_count+0
	GOTO       L__main219
L__main222:
	MOVF       _duty+0, 0
	XORLW      20
	BTFSS      STATUS+0, 2
	GOTO       L__main225
	MOVLW      33
	MOVWF      _duty+0
	MOVLW      1
	MOVWF      _on_count+0
	MOVLW      2
	MOVWF      _off_count+0
	GOTO       L__main219
L__main225:
	MOVF       _duty+0, 0
	XORLW      33
	BTFSS      STATUS+0, 2
	GOTO       L__main228
	MOVLW      50
	MOVWF      _duty+0
	MOVLW      2
	MOVWF      _on_count+0
	MOVLW      2
	MOVWF      _off_count+0
	GOTO       L__main219
L__main228:
	MOVF       _duty+0, 0
	XORLW      50
	BTFSS      STATUS+0, 2
	GOTO       L__main231
	MOVLW      66
	MOVWF      _duty+0
	MOVLW      2
	MOVWF      _on_count+0
	MOVLW      1
	MOVWF      _off_count+0
	GOTO       L__main219
L__main231:
	MOVF       _duty+0, 0
	XORLW      66
	BTFSS      STATUS+0, 2
	GOTO       L__main234
	MOVLW      80
	MOVWF      _duty+0
	MOVLW      4
	MOVWF      _on_count+0
	MOVLW      1
	MOVWF      _off_count+0
	GOTO       L__main219
L__main234:
	MOVF       _duty+0, 0
	XORLW      80
	BTFSS      STATUS+0, 2
	GOTO       L__main237
	MOVLW      100
	MOVWF      _duty+0
	GOTO       L__main219
L__main237:
L__main219:
	GOTO       L__main212
L__main218:
	MOVF       _sw_mode+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__main240
	MOVLW      5
	ADDWF      _duty+0, 0
	MOVWF      FLOC__main+0
	MOVF       FLOC__main+0, 0
	MOVWF      _duty+0
	MOVLW      5
	MOVWF      R4+0
	MOVF       FLOC__main+0, 0
	MOVWF      R0+0
	CALL       _Div_8x8_U+0
	MOVF       R0+0, 0
	MOVWF      R1+0
	RLF        R1+0, 1
	BCF        R1+0, 0
	MOVF       R1+0, 0
	MOVWF      _on_count+0
	MOVF       R1+0, 0
	SUBLW      40
	MOVWF      _off_count+0
	MOVLW      1
	MOVWF      FARG_EEPROM_Write_address+0
	MOVF       FLOC__main+0, 0
	MOVWF      FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
	GOTO       L__main212
L__main240:
L__main212:
L__main210:
	MOVF       _duty+0, 0
	XORLW      100
	BTFSS      STATUS+0, 2
	GOTO       L__main242
	BCF        INTE_bit+0, BitPos(INTE_bit+0)
	BCF        INTF_bit+0, BitPos(INTF_bit+0)
	BSF        RB1_bit+0, BitPos(RB1_bit+0)
	GOTO       L__main243
L__main242:
	MOVF       _sw_mode+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__main245
	MOVF       _duty+0, 0
	MOVWF      FARG_calc_tmr_duty+0
	MOVF       main_freq+0, 0
	MOVWF      FARG_calc_tmr_freq+0
	CALL       _calc_tmr+0
L__main245:
	BSF        INTE_bit+0, BitPos(INTE_bit+0)
	BCF        INTF_bit+0, BitPos(INTF_bit+0)
L__main243:
	MOVF       _duty+0, 0
	MOVWF      FARG_display_number_num+0
	CALL       _display_number+0
L__main207:
	MOVF       main_turn+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__main248
	MOVF       _duty+0, 0
	SUBLW      0
	BTFSC      STATUS+0, 0
	GOTO       L__main251
	MOVF       _sw_mode+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__main256
	MOVLW      5
	SUBWF      _duty+0, 1
	GOTO       L__main253
L__main256:
	MOVF       _sw_mode+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__main259
	MOVF       _duty+0, 0
	XORLW      20
	BTFSS      STATUS+0, 2
	GOTO       L__main263
	CLRF       _duty+0
	GOTO       L__main260
L__main263:
	MOVF       _duty+0, 0
	XORLW      33
	BTFSS      STATUS+0, 2
	GOTO       L__main266
	MOVLW      20
	MOVWF      _duty+0
	MOVLW      1
	MOVWF      _on_count+0
	MOVLW      4
	MOVWF      _off_count+0
	GOTO       L__main260
L__main266:
	MOVF       _duty+0, 0
	XORLW      50
	BTFSS      STATUS+0, 2
	GOTO       L__main269
	MOVLW      33
	MOVWF      _duty+0
	MOVLW      1
	MOVWF      _on_count+0
	MOVLW      2
	MOVWF      _off_count+0
	GOTO       L__main260
L__main269:
	MOVF       _duty+0, 0
	XORLW      66
	BTFSS      STATUS+0, 2
	GOTO       L__main272
	MOVLW      50
	MOVWF      _duty+0
	MOVLW      2
	MOVWF      _on_count+0
	MOVLW      2
	MOVWF      _off_count+0
	GOTO       L__main260
L__main272:
	MOVF       _duty+0, 0
	XORLW      80
	BTFSS      STATUS+0, 2
	GOTO       L__main275
	MOVLW      66
	MOVWF      _duty+0
	MOVLW      2
	MOVWF      _on_count+0
	MOVLW      1
	MOVWF      _off_count+0
	GOTO       L__main260
L__main275:
	MOVF       _duty+0, 0
	XORLW      100
	BTFSS      STATUS+0, 2
	GOTO       L__main278
	MOVLW      80
	MOVWF      _duty+0
	MOVLW      4
	MOVWF      _on_count+0
	MOVLW      1
	MOVWF      _off_count+0
	GOTO       L__main260
L__main278:
L__main260:
	GOTO       L__main253
L__main259:
	MOVF       _sw_mode+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__main281
	MOVLW      5
	SUBWF      _duty+0, 0
	MOVWF      FLOC__main+0
	MOVF       FLOC__main+0, 0
	MOVWF      _duty+0
	MOVLW      5
	MOVWF      R4+0
	MOVF       FLOC__main+0, 0
	MOVWF      R0+0
	CALL       _Div_8x8_U+0
	MOVF       R0+0, 0
	MOVWF      R1+0
	RLF        R1+0, 1
	BCF        R1+0, 0
	MOVF       R1+0, 0
	MOVWF      _on_count+0
	MOVF       R1+0, 0
	SUBLW      40
	MOVWF      _off_count+0
	MOVLW      1
	MOVWF      FARG_EEPROM_Write_address+0
	MOVF       FLOC__main+0, 0
	MOVWF      FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
	GOTO       L__main253
L__main281:
L__main253:
L__main251:
	MOVF       _duty+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__main283
	BCF        INTE_bit+0, BitPos(INTE_bit+0)
	BCF        INTF_bit+0, BitPos(INTF_bit+0)
	BCF        RB1_bit+0, BitPos(RB1_bit+0)
	GOTO       L__main284
L__main283:
	MOVF       _sw_mode+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__main286
	MOVF       _duty+0, 0
	MOVWF      FARG_calc_tmr_duty+0
	MOVF       main_freq+0, 0
	MOVWF      FARG_calc_tmr_freq+0
	CALL       _calc_tmr+0
L__main286:
	BSF        INTE_bit+0, BitPos(INTE_bit+0)
	BCF        INTF_bit+0, BitPos(INTF_bit+0)
L__main284:
	MOVF       _duty+0, 0
	MOVWF      FARG_display_number_num+0
	CALL       _display_number+0
L__main248:
	GOTO       L__main202
L_end_main:
	GOTO       $+0
; end of _main
